// ==============================================================
//	This file is part of The Glest Advanced Engine
//
//	Copyright (C) 2008-2009	Daniel Santos
//
//  GPL V2, see source/licence.txt
// ==============================================================

#ifndef _SHARED_INPUT_ENUMS_
#define _SHARED_INPUT_ENUMS_

#include "util.h"
using Shared::Util::EnumNames;

namespace Shared { namespace Platform {

STRINGY_ENUM( MouseButton,
	UNKNOWN,
	LEFT,
	MIDDLE,
	RIGHT,
	WHEEL_UP,
	WHEEL_DOWN,
	BUTTON_X1,
	BUTTON_X2
)

STRINGY_ENUM( KeyCode, 
	NONE,
	UNKNOWN,
	L_BUTTON,
	R_BUTTON,
	M_BUTTON,
	X_BUTTON1,
	X_BUTTON2,
	BACK_SPACE,
	TAB,
	CLEAR,
	RETURN,
	PAUSE,
	IME_KANA,
	IME_HANGUL,
	IME_JUNJA,
	IME_FINAL,
	IME_HANJA,
	IME_KANJI,
	ESCAPE,
	IME_CONVERT,
	IME_NON_CONVERT,
	IME_ACCEPT,
	IME_MODE_CHANGE,
	IME_PROCESS,
	SPACE,
	EXCLAIM,
	DOUBLE_QUOTE,
	HASH,
	DOLLAR,
	PERCENT,
	AMPERSAND,
	QUOTE,
	LEFT_PAREN,
	RIGHT_PAREN,
	ASTERISK,
	PLUS,
	COMMA,
	MINUS,
	PERIOD,
	SLASH,
	ZERO,
	ONE,
	TWO,
	THREE,
	FOUR,
	FIVE,
	SIX,
	SEVEN,
	EIGHT,
	NINE,
	COLON,
	SEMI_COLON,
	LESS,
	EQUAL,
	GREATER,
	QUESTION_MARK,
	AT,
	A,
	B,
	C,
	D,
	E,
	F,
	G,
	H,
	I,
	J,
	K,
	L,
	M,
	N,
	O,
	P,
	Q,
	R,
	S,
	T,
	U,
	V,
	W,
	X,
	Y,
	Z,
	LEFT_BRACKET,
	BACK_SLASH,
	RIGHT_BRACKET,
	CARET,
	UNDER_SCORE,
	BACK_QUOTE,
	DELETE_,
	WORLD_0,
	WORLD_1,
	WORLD_2,
	WORLD_3,
	WORLD_4,
	WORLD_5,
	WORLD_6,
	WORLD_7,
	WORLD_8,
	WORLD_9,
	WORLD_10,
	WORLD_11,
	WORLD_12,
	WORLD_13,
	WORLD_14,
	WORLD_15,
	WORLD_16,
	WORLD_17,
	WORLD_18,
	WORLD_19,
	WORLD_20,
	WORLD_21,
	WORLD_22,
	WORLD_23,
	WORLD_24,
	WORLD_25,
	WORLD_26,
	WORLD_27,
	WORLD_28,
	WORLD_29,
	WORLD_30,
	WORLD_31,
	WORLD_32,
	WORLD_33,
	WORLD_34,
	WORLD_35,
	WORLD_36,
	WORLD_37,
	WORLD_38,
	WORLD_39,
	WORLD_40,
	WORLD_41,
	WORLD_42,
	WORLD_43,
	WORLD_44,
	WORLD_45,
	WORLD_46,
	WORLD_47,
	WORLD_48,
	WORLD_49,
	WORLD_50,
	WORLD_51,
	WORLD_52,
	WORLD_53,
	WORLD_54,
	WORLD_55,
	WORLD_56,
	WORLD_57,
	WORLD_58,
	WORLD_59,
	WORLD_60,
	WORLD_61,
	WORLD_62,
	WORLD_63,
	WORLD_64,
	WORLD_65,
	WORLD_66,
	WORLD_67,
	WORLD_68,
	WORLD_69,
	WORLD_70,
	WORLD_71,
	WORLD_72,
	WORLD_73,
	WORLD_74,
	WORLD_75,
	WORLD_76,
	WORLD_77,
	WORLD_78,
	WORLD_79,
	WORLD_80,
	WORLD_81,
	WORLD_82,
	WORLD_83,
	WORLD_84,
	WORLD_85,
	WORLD_86,
	WORLD_87,
	WORLD_88,
	WORLD_89,
	WORLD_90,
	WORLD_91,
	WORLD_92,
	WORLD_93,
	WORLD_94,
	WORLD_95,
	KEYPAD_0,
	KEYPAD_1,
	KEYPAD_2,
	KEYPAD_3,
	KEYPAD_4,
	KEYPAD_5,
	KEYPAD_6,
	KEYPAD_7,
	KEYPAD_8,
	KEYPAD_9,
	KEYPAD_PERIOD,
	KEYPAD_DIVIDE,
	KEYPAD_MULTIPLY,
	KEYPAD_MINUS,
	KEYPAD_PLUS,
	KEYPAD_ENTER,
	KEYPAD_EQUAL,
	ARROW_UP,
	ARROW_DOWN,
	ARROW_RIGHT,
	ARROW_LEFT,
	INSERT,
	HOME,
	END,
	PAGE_UP,
	PAGE_DOWN,
	FUNCTION_1,
	FUNCTION_2,
	FUNCTION_3,
	FUNCTION_4,
	FUNCTION_5,
	FUNCTION_6,
	FUNCTION_7,
	FUNCTION_8,
	FUNCTION_9,
	FUNCTION_10,
	FUNCTION_11,
	FUNCTION_12,
	FUNCTION_13,
	FUNCTION_14,
	FUNCTION_15,
	FUNCTION_16,
	FUNCTION_17,
	FUNCTION_18,
	FUNCTION_19,
	FUNCTION_20,
	FUNCTION_21,
	FUNCTION_22,
	FUNCTION_23,
	FUNCTION_24,
	NUM_LOCK,
	CAPS_LOCK,
	SCROLL_LOCK,
	LEFT_SHIFT,
	RIGHT_SHIFT,
	LEFT_CTRL,
	RIGHT_CTRL,
	LEFT_ALT,
	RIGHT_ALT,
	LEFT_META,
	RIGHT_META,
	RIGHT_SUPER,
	LEFT_SUPER,
	MODE,
	COMPOSE,
	HELP,
	PRINT,
	SYS_REQ,
	BREAK,
	MENU,
	POWER,
	EURO,
	UNDO,
	BROWSER_BACK,
	BROWSER_FORWARD,
	BROWSER_REFRESH,
	BROWSER_STOP,
	BROWSER_SEARCH,
	BROWSER_FAVORITES,
	BROWSER_HOME,
	VOLUME_MUTE,
	VOLUME_DOWN,
	VOLUME_UP,
	MEDIA_NEXT,
	MEDIA_PREV,
	MEDIA_STOP,
	MEDIA_PLAY_PAUSE,
	LAUNCH_MAIL,
	LAUNCH_MEDIA,
	LAUNCH_APP1,
	LAUNCH_APP2,
	PLAY,
	ZOOM

)

enum KeyModifier {

	kmNone		= 0x0000,
	kmLShift	= 0x0001,
	kmRShift	= 0x0002,/*
	kmAnyShift	= 0x0004,
	kmAnyCtrl	= 0x0008,
	kmAnyAlt	= 0x0010,
	kmAnyMeta	= 0x0020,*/
	kmLCtrl		= 0x0040,
	kmRCtrl		= 0x0080,
	kmLAlt		= 0x0100,
	kmRAlt		= 0x0200,
	kmLMeta		= 0x0400,
	kmRMeta		= 0x0800,
	kmNum		= 0x1000,
	kmCaps		= 0x2000,
	kmMode		= 0x4000,
	kmSuper		= 0x8000,
};

}}

#endif
